<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0">
  <xsl:output method="xml"/>

    <xsl:param name="context-uri" select="'http://www.gigascale.org/caltrop/data/platforms/DefaultContext.xml'"/>
    <xsl:variable name="context" select="document($context-uri)/Context"/>
    <!-- If you have no internet connection, use this line for debugging purposes instead:
        <xsl:param name="context" select="document('../../web/data/platforms/DefaultContext.xml')/Context"/>
    -->


    <xsl:template match="Stmt[@kind='While']">
        <Expr kind="Application">
            <Expr kind="Var" name="{$context/Procedure[@name='while-procedure']/@procedure}" old="false"/>
            <Expr kind="Tuple">
                <Expr kind="Lambda">
                    <Type name="FIXME"/>
                    <xsl:apply-templates select="Expr"/>
                </Expr>
                <Expr kind="Proc">
                    <Stmt kind="Block">
                        <xsl:apply-templates select="Stmt|VarDecl"/>
                    </Stmt>
                </Expr>
            </Expr>
        </Expr>
    </xsl:template>

    <xsl:template match="*">
        <xsl:copy>
            <xsl:for-each select="@*">
                <xsl:attribute name="{name()}"><xsl:value-of select="."/></xsl:attribute>
            </xsl:for-each>
            <xsl:apply-templates select="*"/>
        </xsl:copy>
    </xsl:template>

</xsl:stylesheet>
